
/*
 * This is a template platform module.
 *
 * Every platform is a ES2015 module which must expose:
 * - Account (a subclass of 'Account'; a bit confusing, I know)
 * - name (a String)
 * - signUp (a function that must return a Promise to a set of config options
 *      for a new configured account)
 */

import Account from '../abstracts/account';


class TemplateAccount extends Account {
	// Constructor receives:
	// - A callback function for emitting updates
	// - The Vorpal instance, to enable printing out system messages
	// - A dictionary of options, as initialized by the signUp() static method,
	//    possibly tweaked by the user running "config set ...".
	constructor(callback, vorpal, opts) {
		// ...
	}
	// ...
}

export DemoAccount as Account;

export function signUp() {
	// Prompt for stuff, returning a Promise for the config opts for a new instance
	return Promise.resolve({});
}

export const name = 'template';
